#include "MyVector.h"
#include <string>
#include <cmath>

using namespace std;

#ifndef M_PI
#define M_PI 3.1415926535897932384626433832795
#endif


MyVector::~MyVector ()
{
};

ostream& operator<< ( ostream& os,const MyVector& MV )
{
 os << "[" << MV.x << ";" << MV.y << ";" << MV.z << "]\n";
 return (os);
};

istream& operator>> ( istream& is, MyVector& MV )
{
   string s;
   is >> s;
   if  ((s.substr(0,1)!="[")||(s.substr(s.length()-1,1)!="]"))
   {
      cerr << "Errore: input string " << s;
      cerr << " non ha un formato MyVector Valido.\n";
      return is;
   }
   else
   {
    unsigned int temp,temp2;
    temp = s.find(';');
    temp2 = s.find(';',(temp!=s.npos?temp+1:0));
    if ((temp==s.npos)||(temp2==s.npos))
    {
      cerr << "Errore: input string " << s;
      cerr << " non ha un formato MyVector Valido.\n";
      return is;
    }
    else
    {
      string sx,sy,sz;
      sx=s.substr(1,temp-1);
      sy=s.substr(temp+1,temp2-temp-1);
      sz=s.substr(temp2+1,s.length()-temp2-2);
      MV.x = atof(sx.c_str());
      MV.y = atof(sy.c_str());
      MV.z = atof(sz.c_str());
    };
   };
   return is;
}
double MyVector::lung()
{
 return (sqrt( this->x*this->x + this->y*this->y + this->z*this->z ) );
};

MyVector& MyVector::norm()
{
 double temp = sqrt( this->x*this->x + this->y*this->y + this->z*this->z );
 this->x/=temp;
 this->y/=temp;
 this->z/=temp;
 return (*this  );
};

const MyVector operator+(const MyVector& A,const MyVector& B)
{
      return MyVector(A.x+B.x,A.y+B.y,A.z+B.z);
};

const MyVector operator-(const MyVector& A,const MyVector& B)
{
      return MyVector(A.x-B.x,A.y-B.y,A.z-B.z);
};

const MyVector operator*(const MyVector& A,const MyVector& B)
{
      return MyVector (A.y * B.z - A.z * B.y ,
                       A.z * B.x - A.x * B.z ,
                       A.x * B.y - A.y * B.x );
};
const MyVector operator*(const double n,const MyVector& A)
{
       return MyVector(A.x*n,A.y*n,A.z*n);
}
const MyVector operator*(const MyVector& A,const double n)
{
       return MyVector(A.x*n,A.y*n,A.z*n);
}

const MyVector operator/(const MyVector& A,const double n)
{
       return MyVector(A.x/n,A.y/n,A.z/n);
}

const double operator%(const MyVector& A,const MyVector& B)
{
 return (A.x*B.x + A.y*B.y + A.z*B.z);
}


MyVector& MyVector::rotate(double ang,MyVector V){
  MyVector A=V;
  A.norm();
  MyVector D = (A%(*this))*A;
  MyVector B =*this - D ;
  double lung =B.lung();
  B=B/lung;
  MyVector N = A * B;
  double alpha =  M_PI * ( ang / 180.0  );

  *this = cos(alpha) * B + sin(alpha) * N;
  *this = *this * lung + D ;

  return *this ;

}
