#ifndef DEF_MyVector_h
#define DEF_MyVector_h

#include <iostream>

//using namespace std;

class MyVector {
  public:
    double x,y,z;
    MyVector (double a,double b, double c) {x=a;y=b;z=c;};
    MyVector (void) {x=0.0;y=0.0;z=0.0;};
    double lung();
    MyVector& norm();
    MyVector& rotate(double ang,MyVector V);
    ~MyVector ();
    MyVector& operator=(const MyVector& B)
              {x=B.x;y=B.y;z=B.z;return *this;};
    MyVector& operator+=(const MyVector& B)
              {x+=B.x;y+=B.y;z+=B.z;return *this;};
    MyVector& operator-=(const MyVector& B)
              {x-=B.x;y-=B.y;z-=B.z;return *this;};

	friend const MyVector operator+(const MyVector& A,const MyVector& B);
    friend const MyVector operator-(const MyVector& A,const MyVector& B);
    friend const MyVector operator*(const MyVector& A,const MyVector& B);
    friend const MyVector operator*(const double n,const MyVector& A);
    friend const MyVector operator*(const MyVector& A,const double n);
    friend const MyVector operator/(const MyVector& A,const double n);
    friend const double operator%(const MyVector& A,const MyVector& B);

    friend std::ostream& operator<< ( std::ostream& os,const MyVector& MV );
    friend std::istream& operator>> ( std::istream& is, MyVector& MV );

};



#endif
