/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sat May 12 15:28:24 EDT 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "myscene.h"
#include "Browser.h"
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include <GL/glut.h>

using namespace std;

MyScene Scena;
float vel=0;
double myang;

int paused=0;
int originalWindow=0,currentWindow;
int frames=0;

void idle(void)
{
  int time;
  static int time2=0;
  time = glutGet(GLUT_ELAPSED_TIME);
  if (time2==0) time2 = time;
  glutPostWindowRedisplay(currentWindow);
  if (time>time2+10000){
	  time2 =time;
	  cout << (frames/10) << " fps " << "\n";
	  frames = 0;
	  
  };

}


void display(void)
{
  Scena.Cam.Avanza(vel);
  Scena.Draw();
  frames++;
}

void visible(int vis)
{
  if (vis == GLUT_VISIBLE) {
    if (!paused) {
      glutIdleFunc(idle);
    }
  } else {
    glutIdleFunc(NULL);
  }
}

void key(unsigned char key, int px, int py)
{
  switch (key) {
  case 27:
    exit(0);
    break;
  }
}

void  keyup(unsigned char key, int x, int y)
{
switch (key) {
  case 'Q':
  case 'q':
    exit(0);
    break;
  case 'A':
  case 'a':
  case 'Z':
  case 'z':
    break;
  }
}

void special(int key, int x, int y) {
  switch (key) {
  case GLUT_KEY_UP:
	Scena.Cam.Roll(5.0);
    break;
  case GLUT_KEY_DOWN:
	Scena.Cam.Roll(-5.0);
    break;
  case GLUT_KEY_LEFT:
    Scena.Cam.rotate(10.0);
    break;
  case GLUT_KEY_RIGHT:
    Scena.Cam.rotate(-10.0);
    break;
  }
}

void specialup(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_UP:
    break;
  case GLUT_KEY_LEFT:
    break;
  case GLUT_KEY_RIGHT:
    break;
  }
}



void initWindow(void)
{
  glutIgnoreKeyRepeat(1);

  glutDisplayFunc(display);
  glutVisibilityFunc(visible);
  glutKeyboardFunc(key);
  glutKeyboardUpFunc(keyup);
  glutSpecialFunc(special);
  glutSpecialUpFunc(specialup);
  //glutJoystickFunc(joystick, 100);

  Scena.InitGL();

  currentWindow = glutGetWindow();
}



void AddCielo()
{
	unsigned int start;
	start = Scena.Points.size();
	MyPoint V1(10000,100,-10000);
	V1.u = 0; V1.v = 0;
	Scena.Points.push_back(V1);
	V1 = MyPoint (10000,100,10000);
	V1.u = 20; V1.v = 0;
	Scena.Points.push_back(V1);
	V1 = MyPoint (-10000,100,10000);
	V1.u = 20; V1.v = 20;
	Scena.Points.push_back(V1);
	V1 = MyPoint (-10000,100,-10000);
	V1.u = 0; V1.v = 20;
	Scena.Points.push_back(V1);

	MyParts P;
	P.material = 0;
	MyTriangle T(&Scena.Points,start,start+1,start+2);
	P.push_back (T);
	MyTriangle T2(&Scena.Points,start,start+2,start+3);
	P.push_back (T2);
	MyObject O;
	
	O.push_back(P);
	int t = Scena.size();
	Scena.push_back(O);
	Scena[t].mc = & Scena.Materials ;
	Scena[t].mp = & Scena.Points ;

};


void AddTerreno()
{
	unsigned int start;
	#define MAX_TERRAIN 40
	#define MAX_TERRAIN_2 20
	int terreno[MAX_TERRAIN][MAX_TERRAIN] =
	{ { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	  { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	

	start = Scena.Points.size();
	int u=0,v=0;
	float  height;
	int x,y;
	for (x=0;x<MAX_TERRAIN;x+=1){
		v=0;
		for (y=0;y<MAX_TERRAIN;y+=1){
			height = (
						(rand()* (
						(x-MAX_TERRAIN_2)/5 *
						(x-MAX_TERRAIN_2)/5 *
						(x-MAX_TERRAIN_2)/5 *
						(x-MAX_TERRAIN_2)/5 +
						(y-MAX_TERRAIN_2)/5 *
						(y-MAX_TERRAIN_2)/5 *
						(y-MAX_TERRAIN_2)/5 *
						(y-MAX_TERRAIN_2)/5 ) 
					 )/RAND_MAX) - 10;  

			MyPoint V1((x-MAX_TERRAIN_2)*20,height  ,(y-MAX_TERRAIN_2)*20);
			V1.u = u; V1.v = v;
			Scena.Points.push_back(V1);
			v++;
			if (v==2) v=0;
		};
		u++;
		if (u==2) u=0;
		
	};

	MyParts P;
	P.material = 1;
	for (x=0;x<MAX_TERRAIN-1;x+=1){
		for (y=0;y<MAX_TERRAIN-1;y+=1){
			MyTriangle *T1 = new MyTriangle(&Scena.Points,
											start+y*MAX_TERRAIN+x,
											start+y*MAX_TERRAIN+x+1,
											start+(y+1)*MAX_TERRAIN+x);
			MyTriangle *T2 = new MyTriangle(&Scena.Points,
											start+(y+1)*MAX_TERRAIN+x,
											start+y*MAX_TERRAIN+x+1,
											start+(y+1)*MAX_TERRAIN+x+1);
			P.push_back (*T1);
			P.push_back (*T2);
			delete T1;
			delete T2;

		};
	};

	MyObject O;
	
	O.push_back(P);
	int t = Scena.size();
	Scena.push_back(O);
	Scena[t].mc = & Scena.Materials ;
	Scena[t].mp = & Scena.Points ;

};


unsigned int AggPuntiSez (MyVector A,MyVector Di,MyVector Ri,float v)
{
	MyPoint P;
	MyVector T;
	unsigned int temp ;
	float Larg = 2.0;

	
	temp = Scena.Points.size();

	T = A;
	P = T;
	P.u = 0;P.v = v;
	Scena.Points.push_back(P);


	T = T + Ri * Larg * 5;
	P = T;
	P.u = 1 ;P.v = v;
	Scena.Points.push_back(P);

	T = T + Ri * Larg/2 + ( Ri * Di ) * Larg * 1 ;
	P = T;
	P.u = 2 ;P.v = v;
	Scena.Points.push_back(P);

	T = T - Ri * Larg + ( Ri * Di ) * Larg * 5 ;
	P = T;
	P.u = 1 ;P.v = v;
	Scena.Points.push_back(P);

	T = T - Ri * Larg * 5 ;
	P = T;
	P.u = 0 ;P.v = v;
	Scena.Points.push_back(P);

	T = T - Ri * Larg * 5 ;
	P = T;
	P.u = 1 ;P.v = v;
	Scena.Points.push_back(P);

	T = T - Ri * Larg - ( Ri * Di ) * Larg * 5 ;
	P = T;
	P.u = 2 ;P.v = v;
	Scena.Points.push_back(P);

	T = T + Ri * Larg/2 - ( Ri * Di ) * Larg * 1 ;
	P = T;
	P.u = 1 ;P.v = v;
	Scena.Points.push_back(P);
	
	return temp;

}

float EvalS3(float s,float e,float vs,float ve,float t)
{
	float t2 = t * t;
	float t3 = t2 * t;
	float s0,v0,a,b;
	s0 = s;
	v0 = vs;

	b =  ( s0 + 0.5 * v0 + 0.5 * ve - e ) * 12;
	a =  ve - v0 - 0.5 * b;
	return s0 + v0 * t + 0.5 * a * t2 + 0.166666666 * b * t3;


};


float EvalV3(float s,float e,float vs,float ve,float t)
{
	float t2 = t * t;
	float t3 = t2 * t;
	float s0,v0,a,b;
	s0 = s;
	v0 = vs;

	b =  ( s0 + 0.5 * v0 + 0.5 * ve - e ) * 12;
	a =  ve - v0 - 0.5 * b;
	return v0 + a * t + 0.5 * b * t2;


};



void AggSez(unsigned int s,unsigned int e)
{
	MyObject O;

	MyParts P;
	P.drawable = true;
	P.type = MP_SEC_FLUENT;
	P.material = 2;
	MyTriangle T1(&Scena.Points,s,e+1,e);
	P.push_back (T1);
	MyTriangle T2(&Scena.Points,s,s+1,e+1);
	P.push_back (T2);
	MyTriangle T3(&Scena.Points,s+7,e,e+7);
	P.push_back (T3);
	MyTriangle T4(&Scena.Points,s+7,s,e);
	P.push_back (T4);
	
	O.push_back(P);

	MyParts P2;
	
	P2.drawable = true;
	P2.type = MP_SEC_SOLID;
	P2.material = 3;
	MyTriangle T6(&Scena.Points,s+1,e+2,e+1);
	P2.push_back (T6);
	MyTriangle T7(&Scena.Points,s+1,s+2,e+2);
	P2.push_back (T7);
	MyTriangle T8(&Scena.Points,s+6,e+7,e+6);
	P2.push_back (T8);
	MyTriangle T9(&Scena.Points,s+6,s+7,e+7);
	P2.push_back (T9);

	O.push_back(P2);

	MyParts P3;
	P3.drawable = false;
	P3.type = MP_SEC_BOUND;
	P3.material = Scena.Materials.GetByName("Sez_Avanti");
	MyTriangle T10(&Scena.Points,e,e+1,e+2);
	P3.push_back (T10);
	MyTriangle T11(&Scena.Points,e,e+2,e+3);
	P3.push_back (T11);
	MyTriangle T12(&Scena.Points,e,e+3,e+4);
	P3.push_back (T12);
	MyTriangle T13(&Scena.Points,e,e+4,e+5);
	P3.push_back (T13);
	MyTriangle T14(&Scena.Points,e,e+5,e+6);
	P3.push_back (T14);
	MyTriangle T15(&Scena.Points,e,e+6,e+7);
	P3.push_back (T15);

	O.push_back(P3);

	MyParts P4;
	P4.drawable = false;
	P4.type = MP_SEC_BOUND;
	P4.material = Scena.Materials.GetByName("Sez_Dietro");
	MyTriangle T16(&Scena.Points,s,s+7,s+6);
	P4.push_back (T16);
	MyTriangle T17(&Scena.Points,s,s+6,s+5);
	P4.push_back (T17);
	MyTriangle T18(&Scena.Points,s,s+5,s+4);
	P4.push_back (T18);
	MyTriangle T19(&Scena.Points,s,s+4,s+3);
	P4.push_back (T19);
	MyTriangle T20(&Scena.Points,s,s+3,s+2);
	P4.push_back (T20);
	MyTriangle T21(&Scena.Points,s,s+2,s+1);
	P4.push_back (T21);
	
	O.push_back(P4);


	MyParts P5;
	P5.drawable = false;
	P5.type = MP_SEC_SOLID;
	P5.material = Scena.Materials.GetByName("Sez_Lato");
	MyTriangle T22(&Scena.Points,s+2,e+3,e+2);
	P5.push_back (T22);
	MyTriangle T23(&Scena.Points,s+2,s+3,e+3);
	P5.push_back (T23);
	MyTriangle T24(&Scena.Points,s+3,e+4,e+3);
	P5.push_back (T24);
	MyTriangle T25(&Scena.Points,s+3,s+4,e+4);
	P5.push_back (T25);
	MyTriangle T26(&Scena.Points,s+4,e+5,e+4);
	P5.push_back (T26);
	MyTriangle T27(&Scena.Points,s+4,s+5,e+5);
	P5.push_back (T27);
	MyTriangle T28(&Scena.Points,s+5,e+6,e+5);
	P5.push_back (T28);
	MyTriangle T29(&Scena.Points,s+5,s+6,e+6);
	P5.push_back (T29);
	
	O.push_back(P5);
	



	int t = Scena.size();
	Scena.push_back(O);
	Scena[t].mc = & Scena.Materials ;
	Scena[t].mp = & Scena.Points ;

};

void AddCar()
{
	MyPoint P;
	MyVector T;
	unsigned int temp ;
	float Larg = 2.0;

	
	temp = Scena.Points.size();
	
	P = MyVector ( 0 , 1, Larg * 3 );
	P.u = 0;P.v = 0.5;
	Scena.Points.push_back(P);

	P = MyVector ( - Larg  , 1 , 0);
	P.u = 0;P.v = 0;
	Scena.Points.push_back(P);

	P = MyVector ( + Larg  , 1 , 0);
	P.u = 1;P.v = 1;
	Scena.Points.push_back(P);

	P = MyVector ( 0  , Larg , 0);
	P.u = 0.5 ; P.v = 0.5 ;
	Scena.Points.push_back(P);

	MyParts P2;
	P2.drawable = true;
	P2.material = Scena.Materials.GetByName("Car");
	MyTriangle T1(&Scena.Points,temp ,temp+1,temp+2);
	P2.push_back (T1);
	MyTriangle T2(&Scena.Points,temp+2 ,temp+1,temp+3);
	P2.push_back (T2);
	MyTriangle T3(&Scena.Points,temp ,temp+3,temp+1);
	P2.push_back (T3);
	MyTriangle T4(&Scena.Points,temp ,temp+2,temp+3);
	P2.push_back (T4);



	MyObject O;
	O.name = "Car1";
	//O.Momentum= MyVector (0.0, 2.0, 0.0);
	O.push_back(P2);
	
	int t = Scena.size();
	Scena.push_back(O);
	Scena[t].mc = & Scena.Materials ;
	Scena[t].mp = & Scena.Points ;


}


void AddPista()
{
	//AddCielo();

	AddTerreno();

	unsigned int s1,s2;
	MyVector r,t;
	MyVector Po(0,0,-10),Di(0,0,1),Ri(-1,0,0) ;
	s1 = AggPuntiSez(Po,Di,Ri,0);
	float yra=1;
	for (int i=1;i<15;i++){
		int ra = ((rand()*15)/RAND_MAX - 5);
		yra = yra + ((rand()*2)/RAND_MAX - 0.4 );
	for (int i=1;i<5;i++){
		//Ri.y = Ri.y + (rand()*5)/RAND_MAX - 2.5;
		Ri = Ri * ra;
		Ri.y = yra;
		
		t=Po + Di * 20 + Ri;
		Di= t -	Po;
		Di.norm();
		Ri = Di * MyVector(0,1,0);
		Po=t;
		
		s2 = AggPuntiSez(Po,Di,Ri,i*2);
		AggSez (s1,s2);
		s1=s2;

	}
	};
/*
	Po = MyVector (0,0,10);
	s2 = AggPuntiSez(Po,Di,Ri,4);
	AggSez (s1,s2);
	Po = MyVector (0,0,30);
	unsigned int s3 = AggPuntiSez(Po,Di,Ri,8);
	AggSez (s2,s3);
*/

};


int main(int argc, char *argv[])
{

  ifstream PROVA("Materiali.txt");
  PROVA >> Scena.Materials;
  PROVA.close();
  AddPista();
  AddCar();
 // cout << Scena; 
/*
  for (float f=0; f<1.1; f+=0.1){
	cout << f << " - " << EvalS3(0,1,0,1,f ) << " " << EvalS3(0,1,1,0,f ) << " ";
	cout << f << " - " << EvalV3(0,1,0,1,f ) << " " << EvalV3(0,1,1,0,f ) << "\n";
  };

*/ 

  //cout << Scena.Points ;
/*
  ofstream PROVA2("CUBO2");
  PROVA2 << Scena;
  PROVA2.close();
*/
  
/*
  Scena[0].Momentum = MyVector (-1.0,1.0,0.0);
  Scena[0].P = MyVector (2.0,0.0,0.0);
  Scena[0].V = MyVector (-0.001,0.0,0.0);
*/
/* 

  Scena[1].Momentum = MyVector (1.0,1.0,0.0);
*/  


  Scena.Cam.p = MyVector(0.0f,2.0f, -10.0f);
  Scena.Cam.d = MyVector(0.0f,0.0f, 1.0f) ;
  Scena.Cam.up = MyVector(0.0f, 1.0f, 0.0f) ;

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);

  if (argc > 1 && !strcmp(argv[1], "-fullscreen")) {
    glutGameModeString("640x480:32@60");
    glutEnterGameMode();
  } else {
    originalWindow = glutCreateWindow("Layout");
  }

  initWindow();

  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */

}
