/***************************************************************************
                          myimage.cpp  -  description
                             -------------------
    begin                : Fri May 18 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "myimage.h"
#include <png.h>

using namespace std;

  MyImage::MyImage(const char* NomeFile)
  {
	data=NULL; X=0;Y=0;data_len=0;
    Read (NomeFile);
  };


MyImage::~MyImage(){
  if (data)
      delete data;
}

bool MyImage::ReadPNG(const char* NomeFile)
{
    png_byte header[8];
    FILE *fp = fopen(NomeFile, "rb");
    if (!fp)
    {
        cerr << "I cant' find " << NomeFile << ".\n" ;
        return (false);
    }
    fread(header, 1, 8 , fp);
    png_byte is_png = !png_sig_cmp(header, 0, 8 );
    if (!is_png)
    {
        cerr  << NomeFile << " is not a PNG.\n"   ;
        return (false) ;
    } ;

   png_structp png_ptr = png_create_read_struct
       (PNG_LIBPNG_VER_STRING, NULL,
        NULL, NULL);
    if (!png_ptr)
        return (false);

    png_infop info_ptr = png_create_info_struct(png_ptr);
    if (!info_ptr)
    {
        png_destroy_read_struct(&png_ptr,
           (png_infopp)NULL, (png_infopp)NULL);
        return (false);
    }

    png_infop end_info = png_create_info_struct(png_ptr);
    if (!end_info)
    {
        png_destroy_read_struct(&png_ptr, &info_ptr,
          (png_infopp)NULL);
        return (false);
    }

    png_init_io(png_ptr, fp);
    png_set_sig_bytes(png_ptr,8);

    png_read_png(png_ptr, info_ptr, 0, NULL);
    png_bytep* rows;
    rows = png_get_rows(png_ptr, info_ptr);
    data_len=info_ptr->rowbytes*info_ptr->height*sizeof(png_byte);
    data = new unsigned char[data_len];


    for (unsigned int y=0;y < info_ptr->height; y++ )
    {
      memcpy((data + y * info_ptr->rowbytes * sizeof(png_byte)),
                    rows[y],
                    info_ptr->rowbytes*sizeof(png_byte));
    };
    X = info_ptr->width;
    Y = info_ptr->height;
    channels = info_ptr->channels;
    bpp =   info_ptr->pixel_depth;
    bpc =   info_ptr->bit_depth;
    switch (info_ptr->color_type)   {
        case PNG_COLOR_TYPE_RGB:  color_type = MI_CT_RGB ;break;
        case PNG_COLOR_TYPE_RGBA:  color_type = MI_CT_RGBA ;break;
    }
    png_destroy_read_struct(&png_ptr, &info_ptr, png_infopp_NULL);

    fclose(fp);
  return true;
}


void MyImage::Read(const char *NomeFile){
    string s;
    unsigned int p,p2;
    s=NomeFile;
    p=s.find('.');
    if (p==s.npos)
    {
      cerr << "I cant' find image extension in '" << NomeFile << "'" ;
      return;
    };
    p2=p;
    while (p2!=s.npos)
    {
      p2=s.find(".",p2+1);
      if (p2!=s.npos) p=p2;
    };
   s=s.substr(p+1,s.length()-p-1)  ;
    if ((s=="png")||(s=="PNG"))
    {
      if (!ReadPNG(NomeFile))
      {
        cerr << "Error while loading: " << NomeFile << ".\n" ;
      } else {
		Name = NomeFile;
	  }
      return;
    };
    cerr << s << " : Image Format not supported.";

}
