/***************************************************************************
                          mymaterial.cpp  -  description
                             -------------------
    begin                : Sat May 19 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mymaterial.h"

using namespace std;

MyMaterial::MyMaterial(){
  emission[0]=0.0f;emission[1]=0.0f;emission[2]=0.0f;emission[3]=1.0f;
  ambient[0]=0.3f;ambient[1]=0.3f;ambient[2]=0.3f;ambient[3]=1.0f;
  diffuse[0]=0.7f;diffuse[1]=0.7f;diffuse[2]=0.7f;diffuse[3]=1.0f;
  specular[0]=1.0f,specular[1]=1.0f,specular[2]=1.0f;specular[3]=1.0f;
  shininess=128;
  twoSided=false;
  mip_level=0;
  enviroment=false;
  img = new MyImage;
}
MyMaterial& MyMaterial::operator=(const MyMaterial& M)
{
    ambient[0]=M.ambient[0];
    ambient[1]=M.ambient[1];
    ambient[2]=M.ambient[2];
    ambient[3]=M.ambient[3];

    diffuse[0]=M.diffuse[0];
    diffuse[1]=M.diffuse[1];
    diffuse[2]=M.diffuse[2];
    diffuse[3]=M.diffuse[3];

    emission[0]=M.emission[0];
    emission[1]=M.emission[1];
    emission[2]=M.emission[2];
    emission[3]=M.emission[3];

    specular[0]=M.specular[0];
    specular[1]=M.specular[1];
    specular[2]=M.specular[2];
    specular[3]=M.specular[3];

    mip_level = M.mip_level;
    name = M.name;
    enviroment = M.enviroment;
    twoSided = M.twoSided;
    shininess = M.shininess;

    img = new MyImage;
    *img=*M.img;
    return *this;
};
MyMaterial::MyMaterial(const MyMaterial& M)
{
    ambient[0]=M.ambient[0];
    ambient[1]=M.ambient[1];
    ambient[2]=M.ambient[2];
    ambient[3]=M.ambient[3];

    diffuse[0]=M.diffuse[0];
    diffuse[1]=M.diffuse[1];
    diffuse[2]=M.diffuse[2];
    diffuse[3]=M.diffuse[3];

    emission[0]=M.emission[0];
    emission[1]=M.emission[1];
    emission[2]=M.emission[2];
    emission[3]=M.emission[3];

    specular[0]=M.specular[0];
    specular[1]=M.specular[1];
    specular[2]=M.specular[2];
    specular[3]=M.specular[3];


    mip_level = M.mip_level;
    name = M.name;
    enviroment = M.enviroment;
    twoSided = M.twoSided;
    shininess = M.shininess;

    img = new MyImage;
    *img=*M.img;
};

MyMaterial::~MyMaterial(){
  if (img) delete img;
}

void MyMaterial::setTex(const char *NomeFile){
  if (img) delete img;
  img = new MyImage(NomeFile);
  if (!img->data) delete img;
}

void MyMaterial::Activate(){
  GLenum  face=GL_FRONT ;
  
  if (twoSided) {
	glDisable(GL_CULL_FACE); 
	face = GL_FRONT_AND_BACK;
  } else {
	glEnable(GL_CULL_FACE);
	face=GL_FRONT;
  };

  glMaterialfv(face,GL_EMISSION,emission);
  glMaterialfv(face,GL_AMBIENT,ambient);
  glMaterialfv(face,GL_DIFFUSE,diffuse);
  glMaterialfv(face,GL_SPECULAR,specular);
  glMateriali(face,GL_SHININESS,shininess);
  
  if (img)
  {
    if (img->data)
    {
      glEnable(GL_TEXTURE_2D);
      if (enviroment)
      {
        glEnable(GL_TEXTURE_GEN_S);
        glEnable(GL_TEXTURE_GEN_T);

        glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
        glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
       } else {
        glDisable(GL_TEXTURE_GEN_S);
        glDisable(GL_TEXTURE_GEN_T);
       };

      GLint internalFormat;
      glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE,GL_MODULATE);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_NEAREST);

      switch (img->color_type) {
           case MI_CT_RGB:
              internalFormat = GL_RGB;
			  //cout << " RGB\n";
              break;
          case MI_CT_RGBA:
             // glEnable(GL_COLOR_MATERIAL);
             // glColor4f (1.0,1.0,1.0,1.0);
              internalFormat = GL_RGBA;
			  //cout << " RGBA\n";
              break;
      } ;
	  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
      if (mip_level==0)
      {
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
        glTexImage2D(GL_TEXTURE_2D, 0,internalFormat,img->X,img->Y,0,internalFormat,GL_UNSIGNED_BYTE,img->data);
      } else {
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST);
        gluBuild2DMipmaps (GL_TEXTURE_2D,
                                          internalFormat,
                                          img->X,
                                          img->Y,
                                          internalFormat,
                                          GL_UNSIGNED_BYTE,
                                          img->data);
      };
    } else {glDisable(GL_TEXTURE_2D);};
  } else {glDisable(GL_TEXTURE_2D);};
}

void MyMaterial::setAmbient(GLfloat r,GLfloat g,GLfloat b){
  ambient[0]=r;
  ambient[1]=g;
  ambient[2]=b;
}

void MyMaterial::setDiffuse(GLfloat r,GLfloat g,GLfloat b){
  diffuse[0]=r;
  diffuse[1]=g;
  diffuse[2]=b;
}

void MyMaterial::setEmission(GLfloat r,GLfloat g,GLfloat b){
  emission[0]=r;
  emission[1]=g;
  emission[2]=b;
}

void MyMaterial::setSpecular(GLfloat r,GLfloat g,GLfloat b){
  specular[0]=r;
  specular[1]=g;
  specular[2]=b;
}

ostream& operator<< ( ostream& os,const MyMaterial& MV )
{
  string name= MV.name.length()==0?"none":MV.name;
  os << "Material: " << name << "\n";
  os << "Emission - R: " << MV.emission[0];
  os << " G: " << MV.emission[1];
  os << " B: " << MV.emission[2];
  os << " A: " << MV.emission[3] << "\n";
  os << "Ambient - R: " << MV.ambient[0];
  os << " G: " << MV.ambient[1];
  os << " B: " << MV.ambient[2];
  os << " A: " << MV.ambient[3] << "\n";
  os << "Diffuse - R: " << MV.diffuse[0];
  os << " G: " << MV.diffuse[1];
  os << " B: " << MV.diffuse[2];
  os << " A: " << MV.diffuse[3] << "\n";
  os << "Specular - R: " << MV.specular[0];
  os << " G: " << MV.specular[1];
  os << " B: " << MV.specular[2];
  os << " A: " << MV.specular[3] << "\n";
  os << "Shininess: " << MV.shininess << "\n";
  os << "MIP mapping levels: " << MV.mip_level << "\n";
  os << "Two Sided: " << MV.twoSided << "\n";
  os << "Enviroment Mapping: " << MV.enviroment << "\n";
  os << "Texture file: ";
  if (MV.img)
  {
    if (MV.img->data)
    {
      os << MV.img->Name;
    } else { os << "none"; };
  } else { os << "none"; };
  os << "\n";
  return os;
}
istream& operator>> ( istream& is, MyMaterial& MV )
{
  string s;
  is >> s;
  if (s!="Material:")
  {
    cerr << "Error reading Material: first line is " << s << "\n";
    return is;
  }
  is >> s;
  if (s!="none") MV.name = s;

//------------------ start Emission

  is >> s;
  if (s!="Emission")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Emission'\n";
    return is;
  }
  is >> s;
  if (s!="-")
  {
    cerr << "Error reading Material " ;
    cerr << MV.name << " Emission \n";
    return is;
  }
  is >> s;
  if (s!="R:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Emission \n";
    return is;
  }
  is >> s;
  MV.emission[0]=atof ( s.c_str());
  is >> s;
  if (s!="G:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Emission \n";
    return is;
  }
  is >> s;
  MV.emission[1]=atof ( s.c_str());
  is >> s;
  if (s!="B:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Emission \n";
    return is;
  }
  is >> s;
  MV.emission[2]=atof ( s.c_str());
  is >> s;
  if (s!="A:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Emission \n";
    return is;
  }
  is >> s;
  MV.emission[3]=atof ( s.c_str());

  //------------------ end Emission

//------------------ start Ambient

  is >> s;
  if (s!="Ambient")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Ambient'\n";
    return is;
  }
  is >> s;
  if (s!="-")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Ambient \n";
    return is;
  }
  is >> s;
  if (s!="R:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Ambient \n";
    return is;
  }
  is >> s;
  MV.ambient[0]=atof ( s.c_str());
  is >> s;
  if (s!="G:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Ambient \n";
    return is;
  }
  is >> s;
  MV.ambient[1]=atof ( s.c_str());
  is >> s;
  if (s!="B:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Ambient \n";
    return is;
  }
  is >> s;
  MV.ambient[2]=atof ( s.c_str());
  is >> s;
  if (s!="A:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Ambient \n";
    return is;
  }
  is >> s;
  MV.ambient[3]=atof ( s.c_str());

//------------------ end Ambient


//------------------ start Diffuse

  is >> s;
  if (s!="Diffuse")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Diffuse'\n";
    return is;
  }
  is >> s;
  if (s!="-")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Diffuse \n";
    return is;
  }
  is >> s;
  if (s!="R:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Diffuse \n";
    return is;
  }
  is >> s;
  MV.diffuse[0]=atof ( s.c_str());
  is >> s;
  if (s!="G:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Diffuse \n";
    return is;
  }
  is >> s;
  MV.diffuse[1]=atof ( s.c_str());
  is >> s;
  if (s!="B:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Diffuse \n";
    return is;
  }
  is >> s;
  MV.diffuse[2]=atof ( s.c_str());
  is >> s;
  if (s!="A:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Diffuse \n";
    return is;
  }
  is >> s;
  MV.diffuse[3]=atof ( s.c_str());

//------------------ end Diffuse

//------------------ start Specular

  is >> s;
  if (s!="Specular")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Specular'\n";
    return is;
  }
  is >> s;
  if (s!="-")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Specular \n";
    return is;
  }
  is >> s;
  if (s!="R:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Specular \n";
    return is;
  }
  is >> s;
  MV.specular[0]=atof ( s.c_str());
  is >> s;
  if (s!="G:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Specular \n";
    return is;
  }
  is >> s;
  MV.specular[1]=atof ( s.c_str());
  is >> s;
  if (s!="B:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Specular \n";
    return is;
  }
  is >> s;
  MV.specular[2]=atof ( s.c_str());
  is >> s;
  if (s!="A:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " Specular \n";
    return is;
  }
  is >> s;
  MV.specular[3]=atof ( s.c_str());
//------------------ end Specular

  is >> s;
  if (s!="Shininess:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Shininess:'\n";
    return is;
  }
  is >> MV.shininess;

  string temp;
  is >> s;
  is >> temp; s+=" " + temp;
  is >> temp; s+=" " + temp;
  if (s!="MIP mapping levels:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'MIP mapping levels:'\n";
    return is;
  }
  is >> MV.mip_level;

  is >> s;
  is >> temp; s+=" " + temp;
  if (s!="Two Sided:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Two Sided:'\n";
    return is;
  }
  is >> MV.twoSided;

  is >> s;
  is >> temp; s+=" " + temp;
  if (s!="Enviroment Mapping:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Enviroment Mapping:'\n";
    return is;
  }
  is >> MV.enviroment;

  is >> s;
  is >> temp; s+=" " + temp;
  if (s!="Texture file:")
  {
    cerr << "Error reading Material ";
    cerr << MV.name << " : found '" << s << "' instead 'Texture file:'\n";
    return is;
  }
  is >> s;
  if (MV.img)
  {
    delete MV.img;
  }
  if (s!="none")
  {
    MV.img = new MyImage(s.c_str());
  } else {
    MV.img = new MyImage();
  }

  return is;
}


