/***************************************************************************
                          myobject.cpp  -  description
                             -------------------
    begin                : Sun May 20 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "myobject.h"

using namespace std;

MyObject::MyObject():vector<MyParts>(){
  Angle=0.0f;
  P=MyVector(0,0,0);
  V=MyVector(0,0,0);
  Momentum=MyVector(0,0,0);
  drawable=true;
  lista=0;
}
MyObject::~MyObject(){
}


ostream& operator<< ( ostream& os, MyObject& MP )
{
 PARTS_ITERATOR it;
 string n=MP.name==""?"none":MP.name;
 os << "Name: " << MP.name << "\n";
 os << "Drawable: " << MP.drawable  << "\n";
 os << "Parts: " << MP.size() << "\n";
 for(it = MP.begin(); it != MP.end(); it++)
 {
  os << *it ;
 };
  return os;
};
istream& operator>> ( istream& is, MyObject& MP )
{

  string s;
  is >> s;
  if (s!="Name:")
  {
      cerr << "Error in Object: found '" << s << "' expected 'Name:'\n";
      return is;
   };
  is >> MP.name;

  is >> s;
  if (s!="Drawable:")
  {
      cerr << "Error in Object: found '" << s << "' expected 'Drwable:'\n";
      return is;
   };
  is >> MP.drawable;


  is >> s;
  if (s!="Parts:")
  {
      cerr << "Error in Object: first line is " << s << " not Parts:\n";
      return is;
   };
  int i,t;
  is >> i;
  for ( t = 0; t<i; t++)
  {
    MyParts M;
    M.mp = MP.mp;
    is >> M;
    MP.push_back(M);
  };

  return is;
};

void MyObject::Draw(){
  if (!drawable) return;
  glPushMatrix();
  /*glMatrixMode(GL_MODELVIEW);*/

  P+=V;
  glTranslatef(P.x,P.y,P.z);
  
  double l = Momentum.lung();
  if (l>0)
  {
    Angle+=l;
    glRotatef(Angle,Momentum.x,Momentum.y,Momentum.z);
  }
  
  if (lista==0)
  {
    lista = glGenLists(1) ;
    glNewList(lista,GL_COMPILE);


   PARTS_ITERATOR itp;
   TRIANGLE_ITERATOR itt;
   GLfloat V[3];
   GLfloat U[2];
   for(itp = begin(); itp != end(); itp++)
   {
    if (itp->drawable)
    {
	  if ((itp->material>=0) && (itp->material<mc->size()) && 
		  (itp->material!=mc->activemat) ) {
			MyMaterial *TempMC=& (*mc)[itp->material];
			(*mc)[itp->material].Activate();
			mc->activemat=itp->material;
	  }
      glBegin(GL_TRIANGLES);
      for(itt = itp->begin(); itt != itp->end(); itt++)
      {
        V[0]=itt->N.x;
        V[1]=itt->N.y;
        V[2]=itt->N.z;
        glNormal3fv(V);
        V[0]=(*mp)[itt->O].x;
        V[1]=(*mp)[itt->O].y;
        V[2]=(*mp)[itt->O].z;
        U[0]=(*mp)[itt->O].u;
        U[1]=(*mp)[itt->O].v;

        glTexCoord2fv(U);
        glVertex3fv(V);
        V[0]=(*mp)[itt->A].x;
        V[1]=(*mp)[itt->A].y;
        V[2]=(*mp)[itt->A].z;
        U[0]=(*mp)[itt->A].u;
        U[1]=(*mp)[itt->A].v;

        glTexCoord2fv(U);
        glVertex3fv(V);
        V[0]=(*mp)[itt->B].x;
        V[1]=(*mp)[itt->B].y;
        V[2]=(*mp)[itt->B].z;
        U[0]=(*mp)[itt->B].u;
        U[1]=(*mp)[itt->B].v;

        glTexCoord2fv(U);
        glVertex3fv(V);
      };
    glEnd();
    };
   };
    glEndList();
  } else {
     glCallList(lista);
  };
  glPopMatrix();
}
