/***************************************************************************
                          myscene.cpp  -  description
                             -------------------
    begin                : Tue May 21 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "myscene.h"

using namespace std;

MyScene::MyScene():vector<MyObject>(){
	FOGENABLED = true;
	Bg_Color[0]   = 0.4;
	Bg_Color[1]   = 0.5;
	Bg_Color[2]   = 1.0;
	Bg_Color[3]   = 1.0;

}
MyScene::~MyScene(){
}


ostream& operator<< ( ostream& os, MyScene& MP )
{

  os << MP.Materials << "\n";
  os << MP.Points << "\n";
 string n=MP.name==""?"none":MP.name;
 os << "Scena: " << n << "\n";
 os << "Objects: " << MP.size() << "\n";
 OBJECT_ITERATOR it;
 for(it = MP.begin(); it != MP.end(); it++)
 {
  os << *it ;
 };
 return os;

};

istream& operator>> ( istream& is, MyScene& MP )
{
  string s;

  is >> MP.Materials;

  is >> MP.Points;



  is >> s;
  if (s!="Scena:")
  {
      cerr << "Error in Scene found '" << s << "' expected 'Scene:'\n";
      return is;
   };
  is >> s;
  MP.name = s=="none"?"":s;

  is >> s;
  if (s!="Objects:")
  {
      cerr << "Error in Object: first line is " << s << " not Parts:\n";
      return is;
   };
  int i,t;
  is >> i;

  for ( t = 0; t<i; t++)
  {
    MyObject M;
    M.mp = &MP.Points;
    M.mc= &MP.Materials;
    is >> M;
    MP.push_back(M);
  };

  return is;
};

void MyScene::InitGL()
{

  glEnable(GL_DEPTH_TEST);
  //glFrontFace(GL_CCW);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);

  GLfloat al[]={ 0.3f, 0.3f , 0.3f, 1};
  GLfloat dl[]={ 0.7f, 0.7f , 0.7f, 1 };
  GLfloat sl[]={ 1.0f, 1.0f , 1.0f, 1 };
  GLfloat lp[]={ 1.0f, 1000.0f , -0.5 };
//  GLfloat sr[]={ 1.0f, 1.0f , 1.0f };

  glLightfv ( GL_LIGHT0 , GL_AMBIENT , al );
  glLightfv ( GL_LIGHT0 , GL_DIFFUSE , dl );
  glLightfv ( GL_LIGHT0 , GL_SPECULAR , sl );
  glLightfv ( GL_LIGHT0 , GL_POSITION , lp );

  glEnable(GL_LIGHT0);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND); 

  glDepthRange(0.0,10000);

  
  
  glClearColor(Bg_Color[0],Bg_Color[1],Bg_Color[2],Bg_Color[3]);
  if (FOGENABLED)
  {
	glFogfv(GL_FOG_COLOR,Bg_Color);	
	glFogi(GL_FOG_MODE,GL_LINEAR);
	glFogf(GL_FOG_START,0.0);
	glFogf(GL_FOG_END,400.0);
	glEnable(GL_FOG);
  }


  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0,1.0,0.2,2000.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

}

void MyScene::Draw()
{

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


  Cam.Activate();


  glPushMatrix();
  
  for (int i=0;i<this->size();i++)
	(*this)[i].Draw();


  glPopMatrix() ;
  glutSwapBuffers();


}

int MyScene::GetByName(string s)
{
 OBJECT_ITERATOR it;
 int t=0;
 for(it = begin(); it != end(); it++)
 {
  if (it->name==s) return t;
  t++;
 };
 return -1;
}
